#include "userfile.h"
#include "extensions.h"
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <fcntl.h>
#include <ctype.h>
#define umode_t	mode_t
extern char     datapath[MAXPATHLEN];
extern char     rootpath[MAXPATHLEN];
int load_userfile( char *username );
int updateuser(struct UF user);
/***************************************************************************
	COMMAFMT
	Puts commas in an unsigned long.
	Code stolen from SNIPPETS.
***************************************************************************/

size_t 
commafmt( char   		*buf,			/* Buffer for formatted string  */
          int     	bufsize, 	/* Size of buffer               */
          long N ) 	/* Number to convert            */
{
	int 	len = 1;
	int 	posn = 1;
	int 	sign = 1;
   char 	*ptr = buf + bufsize - 1;

	if ( 2 > bufsize )
   {
ABORT: 
		*buf = '\0';
		return 0;
   }

   *ptr-- = '\0';
   --bufsize;
	
   if ( 0L > N )
   {
   	sign = -1;
      N = -N;
   }

   for ( ; len <= bufsize; ++len, ++posn )
   {
   	*ptr-- = (char)( ( N % 10L ) + '0' );
   	if ( 0L == ( N /= 10L ) )
      	break;
   	if ( 0 == ( posn % 3 ) )
   	{
      	*ptr-- = ',';
         ++len;
   	}
   	if ( len >= bufsize )
         goto ABORT;
   }

   if ( 0 > sign )
   {
   	if ( len >= bufsize )
      	goto ABORT;
      *ptr-- = '-';
      ++len;
   }

   memmove( buf, ++ptr, len + 1 );
   return (size_t)len;
}
/*-- end of commafmt() ---------------------------------------------------*/

									 
/***************************************************************************
	TRIM
***************************************************************************/

char *
trim( char *str )
{
	char *ibuf;
	char *obuf;
												 
   if ( str )
   {
   	for ( ibuf = obuf = str; *ibuf; )
      {
        	while ( *ibuf && ( isspace ( *ibuf ) ) )
         	ibuf++;
        	if ( *ibuf && ( obuf != str ) )
            *( obuf++ ) = ' ';
        	while ( *ibuf && ( !isspace ( *ibuf ) ) )
            *( obuf++ ) = *( ibuf++ );
      }
      *obuf = '\0';
   }
   return( str );
}
/*-- end of trim() -------------------------------------------------------*/


/***************************************************************************
	UPDATE_USER
	Writes a user's info file back out.
***************************************************************************/

int updateuser(struct UF user) {		
	struct aclmember *entry;
	int fdes = -1;		/* File descriptor */
	int ct;		/* Generic counter */
	struct stat st;
	char work_buff[MAXPATHLEN];		/* Work buffer */
	char userfile[MAXPATHLEN];
	char userlock[MAXPATHLEN];
	char CREDITS[255] = "CREDITS ";
	char RATIO[255] = "RATIO ";
	char ALLUP[255] = "ALLUP ";
	char ALLDN[255] = "ALLDN ";
	char WKUP[255] = "WKUP ";
	char WKDN[255] = "WKDN ";
	char DAYUP[255] = "DAYUP ";
	char DAYDN[255] = "DAYDN ";
	char MONTHUP[255] = "MONTHUP ";
	char MONTHDN[255] = "MONTHDN ";
	char NUKE[255] = "NUKE ";
	char file_buff[BUFSIZ*4];	
	mode_t oldmask;

	/*
	 * General information fields:
	 */
	sprintf(file_buff, "USER %s\n", (user.custom[0] != '\0') ? user.custom : user.name);
	sprintf(work_buff, "GENERAL %d,%lu %d %lu %lu\n", user.wkly_sec, user.weekly_allotment, user.idle_time, user.traffic_down, user.traffic_up);
	strcat(file_buff, work_buff);
	sprintf(work_buff, "LOGINS %d %d %d %d\n", user.num_logins, user.num_logins_ip, user.max_downloads, user.max_uploads);
	strcat(file_buff, work_buff);
	sprintf(work_buff, "TIMEFRAME %d %d\n", user.inhour, user.outhour);
        strcat(file_buff, work_buff);
	sprintf(work_buff, "FLAGS %s\n", user.flags);
	strcat(file_buff, work_buff);
	sprintf(work_buff, "TAGLINE %s\n", user.tagline);
	strcat(file_buff, work_buff);
	sprintf(work_buff, "DIR %s\n", user.startup_dir);
	strcat(file_buff, work_buff);
	/*
	 * Xfer information fields:
	 */
	ct = 0;
	entry = NULL;
	while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
		sprintf(work_buff, "%ld ", user.statsection[ct].credits);
		strcat(CREDITS, work_buff);
		sprintf(work_buff, "%d ", user.statsection[ct].ratio);
		strcat(RATIO, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_up, user.statsection[ct].bytes_up, user.statsection[ct].seconds_up);
		strcat(ALLUP, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_down, user.statsection[ct].bytes_down, user.statsection[ct].seconds_down);
		strcat(ALLDN, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_up_wk, user.statsection[ct].bytes_up_wk, user.statsection[ct].seconds_up_wk);
		strcat(WKUP, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_down_wk, user.statsection[ct].bytes_down_wk, user.statsection[ct].seconds_down_wk);
		strcat(WKDN, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_up_day, user.statsection[ct].bytes_up_day, user.statsection[ct].seconds_up_day);
		strcat(DAYUP, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_down_day, user.statsection[ct].bytes_down_day, user.statsection[ct].seconds_down_day);
		strcat(DAYDN, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_up_month, user.statsection[ct].bytes_up_month, user.statsection[ct].seconds_up_month);
		strcat(MONTHUP, work_buff);
		sprintf(work_buff, "%d %lu %lu ", user.statsection[ct].files_down_month, user.statsection[ct].bytes_down_month, user.statsection[ct].seconds_down_month);
		strcat(MONTHDN, work_buff);
		sprintf(work_buff, "%lu %d %lu ", user.statsection[ct].last_nuked, user.statsection[ct].times_nuked, user.statsection[ct].bytes_nuked);
		strcat(NUKE, work_buff);
		ct++;
	}
	strcat(CREDITS, "\n");
	strcat(file_buff, CREDITS);
	strcat(RATIO, "\n");
	strcat(file_buff, RATIO);
	strcat(ALLUP, "\n");
	strcat(file_buff, ALLUP);
	strcat(ALLDN, "\n");
	strcat(file_buff, ALLDN);
	strcat(WKUP, "\n");
	strcat(file_buff, WKUP);
	strcat(WKDN, "\n");
	strcat(file_buff, WKDN);
	strcat(DAYUP, "\n");
	strcat(file_buff, DAYUP);
	strcat(DAYDN, "\n");
	strcat(file_buff, DAYDN);
	strcat(MONTHUP, "\n");
	strcat(file_buff, MONTHUP);
	strcat(MONTHDN, "\n");
	strcat(file_buff, MONTHDN);
	strcat(NUKE, "\n");
	strcat(file_buff, NUKE);
		
	sprintf(work_buff, "TIME %d %ld %d %lu\n", user.login_times, user.last_on, user.time_limit, user.time_on_today);
	strcat(file_buff, work_buff);
	sprintf(work_buff, "SLOTS %d %d\n", user.gadmin_max, user.gadmin_leech);
	strcat(file_buff, work_buff);
	/*
	 * GROUPS:
	 */
	for (ct = 0; ct < 10 && user.group_user[ct][0] != '\0'; ct++) {
			sprintf(work_buff, "GROUP %s\n", user.group_user[ct]);
			strcat(file_buff, work_buff);
	}
	for (ct = 0; ct < 10 && user.group_priv[ct][0] != '\0'; ct++) {
			sprintf(work_buff, "PRIVATE %s\n", user.group_priv[ct]);
			strcat(file_buff, work_buff);
	}
	/*
	 * User IPs:
	 */
	for (ct = 0; ct < 10 && user.ip[ct][0] != '\0'; ct++) {
			sprintf(work_buff, "IP %s\n", user.ip[ct]);
			strcat(file_buff, work_buff);
	}
	oldmask = umask(0000);
        snprintf(userfile, MAXPATHLEN, "%s%s/users/%s", rootpath, datapath, user.name);
	snprintf(userlock, MAXPATHLEN, "%s.%u", userfile, getpid() );
        if (stat(userfile, &st) < 0 || !S_ISREG(st.st_mode))
                goto end;
        fdes = open(userlock, O_CREAT | O_WRONLY | O_TRUNC, 0600);
        if (fdes < 0)
                goto end;

        lseek(fdes, 0, L_SET);
        if (write(fdes, file_buff, strlen(file_buff)) != strlen(file_buff) || close(fdes) != 0)
                unlink(userlock);
        else {
                rename(userlock, userfile);
	        chown(userfile, (uid_t)st.st_uid, (gid_t)st.st_gid); 
		chmod(userfile, (umode_t)st.st_mode); /* Keep old permissions */
	}
end:
	umask(oldmask);
	return;	
}
/*-- end of update_user() ------------------------------------------------*/



/***************************************************************************
  CLEAR_UF_STRUCT
  Clears uf struct, setting default values where applicable.
***************************************************************************/

void 
clear_ug_struct( void )
{
   int ct;
      												    
   memset( ug.name, '\0', sizeof( ug.name ) );
   memset( ug.flags, '\0', sizeof( ug.flags ) );
   memset( ug.custom, '\0', sizeof( ug.custom ) );
   ug.traffic_down = 0L;
   ug.traffic_up = 0L;
   ug.weekly_allotment = 0L;
   ug.wkly_sec = 0;
   ug.idle_time = -1;
   strcpy(ug.startup_dir, "/\0");
   strcpy( ug.tagline, "No TagLine Set");
   ug.num_logins = 1;
   ug.num_logins_ip = 0;
   ug.max_downloads = -1;
   ug.max_uploads = -1;
   ug.inhour = 0;
   ug.outhour = 0;
   
   for (ct = 0; ct < 10; ct++) {
      ug.statsection[ct].credits = 0L;
      ug.statsection[ct].ratio = -1;
      ug.statsection[ct].files_up = 0;
      ug.statsection[ct].bytes_up = 0L;
      ug.statsection[ct].seconds_up = 0L;	
      ug.statsection[ct].files_down = 0;
      ug.statsection[ct].bytes_down = 0L;
      ug.statsection[ct].seconds_down = 0L;
      ug.statsection[ct].files_up_wk = 0;
      ug.statsection[ct].bytes_up_wk = 0L;
      ug.statsection[ct].seconds_up_wk = 0L;	           
      ug.statsection[ct].files_down_wk = 0;
      ug.statsection[ct].bytes_down_wk = 0L;
      ug.statsection[ct].seconds_down_wk = 0L;
      ug.statsection[ct].files_up_day = 0;
      ug.statsection[ct].bytes_up_day = 0L;
      ug.statsection[ct].seconds_up_day = 0L;
      ug.statsection[ct].files_down_day = 0;
      ug.statsection[ct].bytes_down_day = 0L;
      ug.statsection[ct].seconds_down_day = 0L;
      ug.statsection[ct].files_up_month = 0;
      ug.statsection[ct].bytes_up_month = 0L;
      ug.statsection[ct].seconds_up_month = 0L;
      ug.statsection[ct].files_down_month = 0;
      ug.statsection[ct].bytes_down_month = 0L;
      ug.statsection[ct].seconds_down_month = 0L;
      ug.statsection[ct].last_nuked = (time_t)0;
      ug.statsection[ct].times_nuked = 0;
      ug.statsection[ct].bytes_nuked = 0L;
      memset(ug.group_user[ct], '\0', sizeof(ug.group_user[ct]));
      memset(ug.group_priv[ct], '\0', sizeof(ug.group_priv[ct]));
      memset(ug.ip[ct], '\0', sizeof(ug.ip[ct]));
   }
   ug.statsection[0].ratio = 3;
   ug.login_times = 0;						  
   ug.last_on = (time_t)0;
   ug.time_limit = 0;
   ug.time_on_today = 0L;
   ug.gadmin_max = -1;   					 
   ug.gadmin_leech = -1;

   return;
}
/*-- end of clear_uf_struct() --------------------------------------------*/
										  
/***************************************************************************
	PARSEVAL
	Parses values in user datafile.
***************************************************************************/

void 
userfile_parseval( struct USERRECORD lvalue )
{
   int ct, cnt;					
   struct aclmember *entry;

   if (!lvalue.arg[0])
   	return;
						
   if ( strcmp( lvalue.keyword, "GENERAL" ) == 0 )
   {
      if (lvalue.arg[0][1] == ',') {
	if (isdigit(lvalue.arg[0][0]))
          ug.wkly_sec = lvalue.arg[0][0]-48;
        lvalue.arg[0]+=2;
      }
      ug.weekly_allotment = strtoul(lvalue.arg[0], (char **)NULL, 0);
      if (lvalue.arg[1])
	      ug.idle_time = atoi(lvalue.arg[1]);
      if (lvalue.arg[2])
      	      ug.traffic_down = strtoul(lvalue.arg[2], (char **)NULL, 0);
      if (lvalue.arg[3])
	      ug.traffic_up = strtoul(lvalue.arg[3], (char **)NULL, 0);
      return;
   }  

   if (strcmp(lvalue.keyword, "LOGINS") == 0) {
      ug.num_logins = atoi(lvalue.arg[0]);
      if (lvalue.arg[1])
	ug.num_logins_ip = atoi(lvalue.arg[1]);
      if (lvalue.arg[2])
	ug.max_downloads = atoi(lvalue.arg[2]);
      if (lvalue.arg[3])
	ug.max_uploads = atoi(lvalue.arg[3]);
      return;
   }

   if (strcmp(lvalue.keyword, "TIMEFRAME") == 0) {
	if (lvalue.arg[0])
	  ug.inhour = atoi(lvalue.arg[0]);
        if (lvalue.arg[1])
          ug.outhour = atoi(lvalue.arg[1]);
   }	
   if ( strcmp( lvalue.keyword, "FLAGS" ) == 0 ) {
      strncpy( ug.flags, lvalue.arg[0], sizeof(ug.flags));
      trim(ug.flags);
      return;
   }

   if ( strcmp( lvalue.keyword, "DIR" ) == 0 ) {
      strncpy( ug.startup_dir, lvalue.arg[0], sizeof(ug.startup_dir));
      trim(ug.startup_dir);
      return;
   }

   if ( strcmp( lvalue.keyword, "CREDITS" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
	if (lvalue.arg[ct]) ug.statsection[cnt].credits = atol(lvalue.arg[ct++]);
	cnt++;
      }
      return;
   }
   
   if (strcmp(lvalue.keyword, "RATIO") == 0) {
	ct = 0;
        entry = NULL;
        while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
		if (lvalue.arg[ct]) {
			ug.statsection[ct].ratio = atoi(lvalue.arg[ct]);
		        ct++;
		}
	}
        return;
   }	
   if ( strcmp( lvalue.keyword, "ALLUP" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_up = atoi( lvalue.arg[ct++]);
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_up = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_up = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        cnt++;
      }
      return;
   }
	
   if ( strcmp( lvalue.keyword, "ALLDN" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_down = atoi( lvalue.arg[ct++]);
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_down = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_down = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        cnt++;
      }
      return;
   }
	
   if ( strcmp( lvalue.keyword, "WKUP" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_up_wk = atoi( lvalue.arg[ct++]);
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_up_wk = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_up_wk = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	
        cnt++;
      }
      return;
   }
                           
   if ( strcmp( lvalue.keyword, "WKDN" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_down_wk = atoi( lvalue.arg[ct++]);
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_down_wk = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_down_wk = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	
 	cnt++;
      }
      return;
   }
 
   if ( strcmp( lvalue.keyword, "DAYUP" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_up_day = atoi( lvalue.arg[ct++]);
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_up_day = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_up_day = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	
        cnt++;
      }	
      return;
   }

   if ( strcmp( lvalue.keyword, "DAYDN" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_down_day = atoi( lvalue.arg[ct++] );
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_down_day = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_down_day = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
	cnt++;
      }
      return;
   }

   if ( strcmp( lvalue.keyword, "MONTHUP" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].files_up_month = atoi( lvalue.arg[ct++] );
        if (lvalue.arg[ct]) ug.statsection[cnt].bytes_up_month = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
        if (lvalue.arg[ct]) ug.statsection[cnt].seconds_up_month = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	      	
	cnt++;
      }
      return;
   }
   	
   if ( strcmp( lvalue.keyword, "MONTHDN" ) == 0 )
   {
     ct = 0;
     cnt = 0;
     entry = NULL;
     while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
      if (lvalue.arg[ct]) ug.statsection[cnt].files_down_month = atoi( lvalue.arg[ct++] );
      if (lvalue.arg[ct]) ug.statsection[cnt].bytes_down_month = strtoul(lvalue.arg[ct++], (char **)NULL, 0);	
      if (lvalue.arg[ct]) ug.statsection[cnt].seconds_down_month = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
      cnt++;
     }
     return;
   }

   if ( strcmp( lvalue.keyword, "NUKE" ) == 0 )
   {
      ct = 0;
      cnt = 0;
      entry = NULL;
      while (ct < 10 && getaclentry("stat_section", &entry) && ARG0 && ARG1 != NULL) {
        if (lvalue.arg[ct]) ug.statsection[cnt].last_nuked = atol(lvalue.arg[ct++] );
	if (lvalue.arg[ct]) ug.statsection[cnt].times_nuked = atoi(lvalue.arg[ct++] );
	if (lvalue.arg[ct]) ug.statsection[cnt].bytes_nuked = strtoul(lvalue.arg[ct++], (char **)NULL, 0);
	cnt++;
      }
      return;
    }

   if ( strcmp( lvalue.keyword, "SLOTS" ) == 0 )
   {
     ug.gadmin_max = atoi(lvalue.arg[0]);
     if (lvalue.arg[1])
	ug.gadmin_leech = atoi(lvalue.arg[1]);
     return;
   }

   if ( strcmp( lvalue.keyword, "TIME" ) == 0 )
   {
      ug.login_times = atoi( lvalue.arg[0]);
      if (lvalue.arg[1])
	      ug.last_on = atol(lvalue.arg[1]);
      if (lvalue.arg[2])
	      ug.time_limit = atoi(lvalue.arg[2]);

      if (lvalue.arg[3] && ug.last_on )
      {
		char datethen[30];
		char datenow[30];
		time_t timenow = time(NULL);
		
		sprintf( datethen, "%-24.24s", ctime(&ug.last_on) );
		sprintf( datenow, "%-24.24s", ctime(&timenow) );
		if ( !memcmp( datenow, datethen, 10 ) )
			ug.time_on_today = atol( lvalue.arg[3] );
		else
			ug.time_on_today = 0L;
      }
      else ug.time_on_today = 0L;	
      return;
   }                         
     						
   if ( strcmp( lvalue.keyword, "GROUP" ) == 0 )
	{
		for ( ct = 0; ct < 10; ct++ )
			if ( ug.group_user[ ct ][ 0 ] == '\0')
			{
				strcpy( ug.group_user[ ct ], lvalue.arg[0]);
            			trim( ug.group_user[ ct ] ); 
				return;
			}
	}
	 
   if ( strcmp( lvalue.keyword, "PRIVATE" ) == 0 )
	{
		for ( ct = 0; ct < 10; ct++ )
			if ( ug.group_priv[ ct ][ 0 ] == '\0')
			{
				strcpy( ug.group_priv[ ct ], lvalue.arg[0]);
			        trim( ug.group_priv[ ct ] ); 
				return;
			}
	}
	
   if ( strcmp( lvalue.keyword, "IP" ) == 0 )
	{
		for ( ct = 0; ct < 10; ct++ )
			if ( ug.ip[ ct ][ 0 ] == '\0')
			{
				strcpy( ug.ip[ ct ], lvalue.arg[0]);
		            	trim( ug.ip[ ct ] ); 
				return;
			}
	}
}  
/*-- end of userfile_parseval() -------------------------------------------*/



/***************************************************************************
	LOAD_USERFILE
	Loads user data for user "username".
	returns 1 on error, 0 otherwise.
***************************************************************************/

int
load_userfile( char *username )
{
	char *ptr, *aclptr;
	FILE *userfile;
	int cnt;
	char *aclbuf, *line;
	struct stat finfo;
	char fname_buff[MAXPATHLEN + 1];
	struct USERRECORD record;

	clear_ug_struct();
	strncpy(ug.name, username, sizeof(ug.name)); 

	sprintf(fname_buff, "%s%s/users/%s", rootpath, datapath, ug.name);
	if ((userfile = fopen(fname_buff, "r")) == NULL) {
		return 1;
	}
	if (fstat(fileno(userfile), &finfo) != 0) {
		fclose(userfile);
		return 1;
	}
	if (finfo.st_size == 0) {
		aclbuf = (char *)calloc(1,1);
	} else {
		if (!(aclbuf = (char *)malloc((unsigned) finfo.st_size + 1))) {
			(void)fclose(userfile);
			return 1;
		}
		if (!fread(aclbuf, (size_t)finfo.st_size, 1, userfile)) {
			aclbuf = NULL;
			(void)fclose(userfile);
			free(aclbuf);
			return 1;
		}
		*(aclbuf + finfo.st_size) = '\0';
	}
	(void)fclose(userfile);
	
	if (!aclbuf || !(*aclbuf)) {
		free(aclbuf);
		return 1;
	}
	aclptr = aclbuf;
	while (*aclptr != '\0') {
		line = aclptr;
		while (*aclptr && *aclptr != '\n')
			aclptr++;
		*aclptr++ = (char) NULL;
		
		if ((ptr = strchr(line, '#')) != NULL)
			*ptr = '\0';

		ptr = strtok(line, " \t");
		if (ptr) {
			if (strcmp(ptr, "UNFO") == 0) {
				strncpy(ug.tagline, line+5, sizeof(ug.tagline));
				trim(ug.tagline);
				continue;
			}
			if (strcmp(ptr, "USER") == 0) {
				strncpy(ug.tagline, line+5, sizeof(ug.custom));
				trim(ug.custom);
				continue;
			}
			if (strcmp(ptr, "TAGLINE") == 0) {
				strncpy(ug.tagline, line+8, sizeof(ug.tagline));
				trim(ug.tagline);
				continue;
			}
			strcpy(record.keyword, ptr);
		 	cnt = 0;
			while ((ptr = strtok(NULL, " \t")) != NULL) {
				if (cnt > MAX_ARGS)   /*MAX ARGS allowed in LINE */
					break;
				record.arg[cnt++] = ptr;
			}
			for (; cnt < MAX_ARGS; cnt++)
				record.arg[cnt] = NULL;
			userfile_parseval(record);
		}
	}

	free(aclbuf);
	return 0;
}
/*-- end of load_userfile() ----------------------------------------------*/
