#include <sys/param.h> 
#include <time.h>

#define MAX_CUSTOM	50
#define MAX_FLAGS	50
#define MAX_ARGS	30
#define MAX_KYLEN	20

int SECTION, CSECTION;

struct USERSTATS {
  long  credits;		/* User credits */
  short int ratio;
  int    files_up;           /* Total # files upped */
  unsigned long  bytes_up;           /* Total # bytes upped */
  time_t seconds_up;         /* Total # seconds spent uploading */
  int    files_down;         /* Total # files downed */
  unsigned long  bytes_down;         /* Total # bytes downed */
  time_t seconds_down;       /* Total # seconds spent downloading */
  int    files_up_wk;        /* Total # files upped (week) */
  unsigned long  bytes_up_wk;        /* Total # bytes upped (week) */
  time_t seconds_up_wk;      /* Total # seconds spent uploading */
  int    files_down_wk;      /* Total # files downed (week) */
  unsigned long  bytes_down_wk;      /* Total # bytes downed (week) */
  time_t seconds_down_wk;    /* Total # seconds spent downloading (week) */
  int    files_up_day;
  unsigned long  bytes_up_day;
  time_t seconds_up_day;
  int    files_down_day;
  unsigned long  bytes_down_day;
  time_t seconds_down_day;
  int    files_up_month;
  unsigned long  bytes_up_month;
  time_t seconds_up_month;
  int    files_down_month;
  unsigned long  bytes_down_month;
  time_t seconds_down_month;
  time_t last_nuked;
  int	times_nuked;
  unsigned long	bytes_nuked;
};

struct UF
{
  char   name[ 24 ];         /* Username */
  short int wkly_sec;
  unsigned long	 weekly_allotment;
  signed int idle_time;
  long	 traffic_down;        /* Throughput on downloads allowed */
  long   traffic_up;	      /* Throughput on uploads allowed */
  short int inhour;	      
  short int outhour;	      /* time when the user can log in */
  char   flags[MAX_FLAGS];
  char   tagline[ 64 ];      /* The user's tagline */
  char   startup_dir[65];     /* Start-up directory */
  int	 num_logins;         /* Number of simultaneous logins allowed */
  int	 num_logins_ip;      /* Number of simultaneous logins allowed from the same IP */
  struct USERSTATS statsection[10];
  int    login_times;        /* # times logged on */  
  time_t last_on;            /* Last date online */
  int    time_limit;         /* Time limit (in minutes) */
  long    time_on_today;      /* Number of minutes spent online today */
  int    gadmin_max;	     /* Number of users the gadmin is allowed to add */
  int	 gadmin_leech;	     /* Number of leech accounts the gadmin is allowed to add */
  char   group_user[ 10 ][ 15 ];  /* Groups this user belongs to */
  char   group_priv[ 10 ][ 15 ];  /* Groups this user belongs to */
  char   ip[ 10 ][ 55 ];     /* IPs allowed for this login */
  char   custom[MAX_CUSTOM];
  int max_downloads;	/* maximum simultaneous downloads allowed */
  int max_uploads;	/* maximum simultaneous uploads allowed */
};	       
struct UF uf;
struct UF ug;

struct USERRECORD {
	char keyword[MAX_KYLEN];
	char *arg[MAX_ARGS];
};

struct UF_CACHE {
	time_t uf_ino;    	/* inode of userfile */
	struct UF usr;   	/* Userfile struct */
	struct UF_CACHE *next;
};

